Package org.apache.sysds.hops

# Class TernaryOp

java.lang.Object
org.apache.sysds.hops.Hop
org.apache.sysds.hops.MultiThreadedHop
org.apache.sysds.hops.TernaryOp

All Implemented Interfaces:
  `ParseInfo`

public class TernaryOp extends MultiThreadedHop
Primary use cases for now, are `quantile (<n-1-matrix>, <n-1-matrix>, <literal>): quantile (A, w, 0.5)` `quantile (<n-1-matrix>, <n-1-matrix>, <scalar>): quantile (A, w, s)` `interquantile (<n-1-matrix>, <n-1-matrix>, <scalar>): interquantile (A, w, s)` Keep in mind, that we also have binaries for it w/o weights. quantile (A, 0.5) quantile (A, s) interquantile (A, s) Note: this hop should be called AggTernaryOp in consistency with AggUnaryOp and AggBinaryOp; however, since there does not exist a real TernaryOp yet - we can leave it as is for now. CTABLE op takes 2 extra inputs with target dimensions for padding and pruning.

## Field Summary

Fields
Modifier and Type
Field
Description
`static boolean`
`ALLOW_CTABLE_SEQUENCE_REWRITES`

### Fields inherited from class org.apache.sysds.hops.Hop

`_beginColumn, _beginLine, _endColumn, _endLine, _filename, _text, CPThreshold`

## Constructor Summary

Constructors
Constructor
Description
`TernaryOp(String l, Types.DataType dt, Types.ValueType vt, Types.OpOp3 o, Hop inp1, Hop inp2, Hop inp3)`
`TernaryOp(String l, Types.DataType dt, Types.ValueType vt, Types.OpOp3 o, Hop inp1, Hop inp2, Hop inp3, Hop inp4, Hop inp5, Hop inp6)`

## Method Summary

Modifier and Type
Method
Description
`boolean`
`allowsAllExecTypes()`
`Object`
`clone()`
`boolean`
`compare(Hop that)`
`Lop`
`constructLops()`
`Types.ExecType`
`findExecTypeTernaryOp()`
`Types.OpOp3`
`getOp()`
`String`
`getOpString()`
`boolean`
`isCTableReshapeRewriteApplicable(Types.ExecType et, Ctable.OperationTypes opType)`
`boolean`
`isGPUEnabled()`
In memory-based optimizer mode (see OptimizerUtils.isMemoryBasedOptLevel()), the exectype is determined by checking this method as well as memory budget of this Hop.
`boolean`
`isMatrixIgnoreZeroRewriteApplicable()`
Used for (1) constructing CP lops (hop-lop rewrite), and (2) in order to determine if dag split after removeEmpty necessary (#2 is precondition for #1).
`boolean`
`isMultiThreadedOpType()`
`boolean`
`isSequenceRewriteApplicable(boolean left)`
`void`
`refreshSizeInformation()`
Update the output size information for this hop.
`void`
`setDisjointInputs(boolean flag)`

### Methods inherited from class org.apache.sysds.hops.MultiThreadedHop

`getMaxNumThreads, setMaxNumThreads`

### Methods inherited from class org.apache.sysds.hops.Hop

`activatePrefetch, addAllInputs, addInput, checkAndSetForcedPlatform, checkAndSetInvalidCPDimsAndSize, clearMemEstimate, colsKnown, compressedSize, computeBoundsInformation, computeBoundsInformation, computeBoundsInformation, computeMemEstimate, computeSizeInformation, computeSizeInformation, computeSizeInformation, constructAndSetLopsDataFlowProperties, createOffsetLop, deactivatePrefetch, dimsKnown, dimsKnown, dimsKnownAny, getBeginColumn, getBeginLine, getBlocksize, getCompressedSize, getDataCharacteristics, getDataType, getDim, getDim1, getDim2, getEndColumn, getEndLine, getExecType, getFederatedOutput, getFilename, getForcedExecType, getHopID, getInput, getInput, getInputMemEstimate, getInputMemEstimate, getInputOutputSize, getIntermediateMemEstimate, getLength, getLops, getMemEstimate, getName, getNnz, getOutputMemEstimate, getOutputMemEstimate, getParent, getSparsity, getSpBroadcastSize, getText, getUpdateType, getValueType, hasCompressedInput, hasFederatedOutput, hasLocalOutput, hasValidCPDimsAndSize, isCompressedOutput, isFederated, isFederatedDataOp, isMatrix, isMemEstimated, isOutputEmptyBlocks, isRequiredDecompression, isScalar, isTransposeSafe, isVisited, prefetchActivated, printErrorLocation, refreshColsParameterInformation, refreshColsParameterInformation, refreshMemEstimates, refreshRowsParameterInformation, refreshRowsParameterInformation, requiresCheckpoint, requiresCompression, requiresLineageCaching, requiresReblock, requiresRecompile, resetExecType, resetRecompilationFlag, resetRecompilationFlag, resetVisitStatus, resetVisitStatus, resetVisitStatus, resetVisitStatusForced, rowsKnown, setBeginColumn, setBeginLine, setBlocksize, setCompressedOutput, setCompressedSize, setDataType, setDim, setDim1, setDim2, setEndColumn, setEndLine, setExecType, setFederatedOutput, setFilename, setForcedExecType, setLops, setMemEstimate, setName, setNnz, setOutputEmptyBlocks, setParseInfo, setRequiresCheckpoint, setRequiresCompression, setRequiresCompression, setRequiresDeCompression, setRequiresLineageCaching, setRequiresReblock, setRequiresRecompile, setText, setUpdateType, setValueType, setVisited, setVisited, someInputFederated, toString, updateLopFedOut, updateLopFedOut`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### ALLOW_CTABLE_SEQUENCE_REWRITES

public static boolean ALLOW_CTABLE_SEQUENCE_REWRITES

## Constructor Details

### TernaryOp

public TernaryOp(String l, Types.DataType dt, Types.ValueType vt, Types.OpOp3 o, Hop inp1, Hop inp2, Hop inp3)

### TernaryOp

public TernaryOp(String l, Types.DataType dt, Types.ValueType vt, Types.OpOp3 o, Hop inp1, Hop inp2, Hop inp3, Hop inp4, Hop inp5, Hop inp6)

## Method Details

### getOp

public Types.OpOp3 getOp()

### setDisjointInputs

public void setDisjointInputs(boolean flag)

### isGPUEnabled

public boolean isGPUEnabled()
Description copied from class: `Hop`
In memory-based optimizer mode (see OptimizerUtils.isMemoryBasedOptLevel()), the exectype is determined by checking this method as well as memory budget of this Hop. Please see findExecTypeByMemEstimate for more detail. This method is necessary because not all operator are supported efficiently on GPU (for example: operations on frames and scalar as well as operations such as table).

Specified by:
  `isGPUEnabled` in class `Hop`
Returns:
  true if the Hop is eligible for GPU Exectype.

### isMultiThreadedOpType

public boolean isMultiThreadedOpType()

Specified by:
  `isMultiThreadedOpType` in class `MultiThreadedHop`

### constructLops

public Lop constructLops()

Specified by:
  `constructLops` in class `Hop`

### getOpString

public String getOpString()

Specified by:
  `getOpString` in class `Hop`

### allowsAllExecTypes

public boolean allowsAllExecTypes()

Specified by:
  `allowsAllExecTypes` in class `Hop`

### findExecTypeTernaryOp

public Types.ExecType findExecTypeTernaryOp()

### refreshSizeInformation

public void refreshSizeInformation()
Description copied from class: `Hop`
Update the output size information for this hop.

Specified by:
  `refreshSizeInformation` in class `Hop`

### clone

public Object clone() throws CloneNotSupportedException

Specified by:
  `clone` in class `Hop`
Throws:
  `CloneNotSupportedException`

### compare

public boolean compare(Hop that)

Specified by:
  `compare` in class `Hop`

### isSequenceRewriteApplicable

public boolean isSequenceRewriteApplicable(boolean left)

### isMatrixIgnoreZeroRewriteApplicable

public boolean isMatrixIgnoreZeroRewriteApplicable()
Used for (1) constructing CP lops (hop-lop rewrite), and (2) in order to determine if dag split after removeEmpty necessary (#2 is precondition for #1).

Returns:
  true if ignore zero rewrite

### isCTableReshapeRewriteApplicable

public boolean isCTableReshapeRewriteApplicable(Types.ExecType et, Ctable.OperationTypes opType)